#version 450 core
#extension GL_GOOGLE_include_directive : require

#include "per_frame.inc"

layout(location = 0) in vec3 inPos;
layout(location = 1) in vec3 inNormal;
layout(location = 2) in vec3 inTangent;
layout(location = 3) in vec2 inUV;

layout(set = 0, binding = 0) uniform Frame {
    PerFrameData frame;
};

layout(set = 1, binding = 0) uniform sampler2D samplerDiffuse;
layout(set = 1, binding = 1) uniform sampler2D samplerNormal;

layout(location = 0) out vec4 outFragColor;

void main() {
    vec3 vertexNormal = normalize(inNormal);
    vec3 vertexTangent = normalize(inTangent);
    vec3 vertexBitangent = cross(vertexTangent, vertexNormal);
    mat3 tangentToWorldSpace = mat3(vertexTangent, vertexBitangent, vertexNormal);
    vec3 normalMapNormal = texture(samplerNormal, inUV).xyz * 2.0 - 1.0;
    vec3 normal = tangentToWorldSpace * normalMapNormal;
    vec4 diffuse = texture(samplerDiffuse, inUV);
    float nDotL = dot(inNormal, normalize(vec3(0.1, -1.0, 0.13)));
    outFragColor = vec4(max(0.23, nDotL) * diffuse.rgb, 1.0f);
    // outFragColor = vec4(inNormal, 1.0);
}
