#version 450 core
#extension GL_GOOGLE_include_directive : require

#include "per_frame.inc"

layout(location = 0) in vec3 inPos;
layout(location = 1) in vec3 inNormal;
layout(location = 2) in vec3 inTangent;
layout(location = 3) in vec2 inUV;

layout(set = 0, binding = 0) uniform Frame {
    PerFrameData frame;
};

layout(location = 0) out vec3 outPos;
layout(location = 1) out vec3 outNormal;
layout(location = 2) out vec3 outTangent;
layout(location = 3) out vec2 outUV;

out gl_PerVertex {
    vec4 gl_Position;
};

void main() {
    gl_Position =  frame.viewProjection * vec4(inPos.xyz, 1.0);
    outPos = inPos;
    outNormal = inNormal;
    outTangent = inTangent;
    outUV = inUV;
}
