#pragma once

#include "stereo_strategy.hpp"

class multiview_stereo final : public stereo_strategy {
public:
    multiview_stereo(vr_app* app);
    ~multiview_stereo();

    bool create();
    virtual void render(VkCommandBuffer command_buffer, lava::index frame) override;

private:
    lava::pipeline_layout::ptr pipeline_layout_;
    VkRenderPass vk_render_pass = VK_NULL_HANDLE;
    lava::attachment::list attachments;
    lava::subpass_dependency::list dependencies;
    lava::subpass::list subpasses;
    lava::rect area;

    bool create_render_pass(const stereo_framebuffer::ptr& left_eye_framebuffer, const stereo_framebuffer::ptr& right_eye_framebuffer);
};