#pragma once

#include "stereo_strategy.hpp"

class naive_stereo final : public stereo_strategy {
public:
    naive_stereo(vr_app* app);
    ~naive_stereo();

    bool create();
    virtual void render(VkCommandBuffer command_buffer, lava::index frame) override;

    struct eye_render_pass {
        lava::render_pass::ptr render_pass;
        lava::graphics_pipeline::ptr pipeline;
    };

private:
    lava::pipeline_layout::ptr pipeline_layout_;
    eye_render_pass render_passes_[2];

    eye_render_pass create_render_pass(const stereo_framebuffer::ptr& framebuffer);
};