#include <liblava/lava.hpp>
#include <glm/glm.hpp>

namespace glsl {
using namespace glm;
#include "res/dpr/per_frame.inc"
}

struct stereo_framebuffer {
    using ptr = std::shared_ptr<stereo_framebuffer>;

    lava::image::ptr color_image;
    lava::attachment::ptr color_attachment;
    lava::image::ptr depth_stencil_image;
    lava::attachment::ptr depth_stencil_attachment;
    VkDescriptorSet per_frame_descriptor_set;
    glsl::PerFrameData per_frame_data;
    lava::buffer::ptr per_frame_ubo;

    inline void destroy() {
        if (color_image) {
            color_image->destroy();
        }
        if (depth_stencil_image) {
            depth_stencil_image->destroy();
        }
        if (per_frame_ubo) {
            per_frame_ubo->destroy();
        }
    }
};
