#pragma once

#include <liblava/lava.hpp>
#include "stereo_framebuffer.hpp"

class vr_app;
class frame_capture;
class pass_timer;

class stereo_strategy {
public:
    inline stereo_strategy(vr_app* app) : app_(app) {}
    virtual bool create() = 0;
    virtual void render(VkCommandBuffer command_buffer, lava::index frame) = 0;
    virtual void render_companion_window(VkCommandBuffer command_buffer) {}
    virtual void update() {}
    virtual void draw_imgui() {}

    inline vr_app* app() const { return app_; }
    frame_capture& frame_capture() const;
    pass_timer& pass_timer() const;

private:
    vr_app* app_;
};
